/****************************************************************/
/*           PROJET SPY BIRD ROBOT INSPECTEUR DE CABLES         */
/*       Tle SI Lycée François Mauriac Andrézieux Bouthéon      */
/*                            Mai 2013                          */
/*  A utiliser avec un shield ardumoto et un module Bluetooth   */
/*        connecté sur la liaison série Rx 0 Tx 1              */
/****************************************************************/
#include <Servo.h>

//Définiion des entrées soties

int sensorPin1 = A5;  
int sensorPin2 = A2; 
int batterie=A1;
int pwm_a =3;
int pwm_b =11;
int dir_a = 12;
int dir_b = 13;

Servo myservo1; 
Servo myservo2; 
Servo myservo3;

//Déclaration et initialisation des variables
int valeurcapteur1;
int valeurcapteur2;
float vbat;
int conv;
unsigned long temps;

int vmot=127;
int angle1=90;
int angle2=60;
int angle3=90;

void setupBlueToothConnection(){

  Serial.begin(115200); //vitesse de transmission Bluetooth à 115200 bauds
  delay(2000);
  Serial.flush();
}

void setup(){ 
  //Paramétrage des entrées sorties

  Serial.begin(115200);

  setupBlueToothConnection();
  pinMode(dir_a,OUTPUT);
  pinMode(dir_b,OUTPUT);   
  digitalWrite(dir_a, HIGH);
  digitalWrite(dir_b, HIGH);
  pinMode(pwm_a,OUTPUT);
  pinMode(pwm_b,OUTPUT);
  myservo1.attach(4); 
  myservo2.attach(5); 
  myservo3.attach(6);
  analogWrite(pwm_a,0);
  analogWrite(pwm_b,0);
  temps=millis();

} 

//Programme principal
void loop() {
  lecture_capt();
  lecture_BT();
  commande_mot();
  commande_servos();
  envoi_bat();
}

//Foncion commande servos
void commande_servos()
{
  myservo1.write(angle1);
  myservo2.write(angle2); 
  myservo3.write(angle3);
}

//Foncion lecture des capteurs
void lecture_capt()
{
  valeurcapteur1 = analogRead(A2);
  valeurcapteur2 = analogRead(A5);
}

//foncion lecture_BT 
void lecture_BT()
{
  if ( Serial.available() > 3){
    if ( Serial.available() == 4){  //véifie qu'on a reçu 3 octets

      vmot=Serial.read(); 
      angle1=Serial.read();
      angle2=Serial.read();
      angle3=Serial.read();
      Serial.flush();
    }
  }   
}
//fin lecture_BT

//fonction commande des moteurs
void commande_mot()
{
  if ((vmot>102)&&(vmot<154)) 
  {
    analogWrite(pwm_a,0);
    analogWrite(pwm_b,0);
  }

  if (vmot>=154) {
    int v=(vmot-140)*(255/115);  
    analogWrite(pwm_a,v);
    analogWrite(pwm_b,v);
    digitalWrite(dir_a,LOW);
    digitalWrite(dir_b,LOW);   

    if (valeurcapteur2<20)
    {
      analogWrite(pwm_a,0);
      analogWrite(pwm_b,0); 
    }
  }

  if (vmot<=102) {
    int v=(116-vmot)*(255/116);  
    analogWrite(pwm_a,v);
    analogWrite(pwm_b,v);
    digitalWrite(dir_a,HIGH);
    digitalWrite(dir_b,HIGH);
    if (valeurcapteur1<20) 
    {
      analogWrite(pwm_a,0);
      analogWrite(pwm_b,0);
    }
  }
}//fin fonction commande_mot

//foncion qui envoie à la tablette la tension batterie 
void envoi_bat()
{
  if((millis()-temps)>60000)//on envoie la tension batterie à la tablette une fois par minute
  {    
    temps=millis();
    conv=analogRead(batterie);
    vbat=float(conv)*(5*13.3)/(4.56*1024);  
    Serial.print(vbat);
    Serial.print(" V");
  }
}

